#!/usr/bin/env python3

import os, fnmatch
import argparse

all_count = 0
newfile = "new_empty.txt"

class bcolors:
    HEADER = '\033[94m'
    GREEN = '\033[92m'
    WARNING = '\033[93m'
    RED = '\033[91m'
    CYAN = '\033[36m'
    ENDC = '\033[0m'
    BOLD = '\033[1m'
    UNDERLINE = '\033[4m'

def find(pattern, path):
    result = []
    for root, dirs, files in os.walk(path):
        for name in files:
            if fnmatch.fnmatch(name, pattern):
                result.append(os.path.join(root, name))
    return result

def show_diff_line(file_name, line_number, line):
    global old_word
    global new_word
    global _color

    if _color:
        print(bcolors.CYAN +"@@ file: {0}, line: {1} @@".format(file_name, line_number)+ bcolors.ENDC)
        print(bcolors.RED +"--- "+ bcolors.ENDC + line.replace(old_word, bcolors.RED + old_word + bcolors.ENDC), end="")
        print(bcolors.GREEN +"+++ "+ bcolors.ENDC + line.replace(old_word, bcolors.GREEN + new_word + bcolors.ENDC))
    else:
        print("@@ file: {0}, line: {1} @@".format(file_name, line_number))
        print("--- "+ line, end="")
        print("+++ "+ line.replace(old_word, new_word))
    #return temp_line

def auto_and_show(file_name):
    count = 0
    line_number = 0
    global all_count
    global old_word
    global new_word
    file = open(file_name, "r")
    file2 = open(newfile, "w")

    for line in file:
        line_number += 1
        line_count = line.count(old_word)

        if line_count > 0:
            show_diff_line(file_name, line_number, line)
            count += line_count
            file2.write(line.replace(old_word, new_word))
        else:
            file2.write(line)
    file.close()
    file2.close()
    all_count += count
    os.replace(newfile, file_name)

def auto_and_not_show(file_name):
    count = 0
    global all_count
    global old_word
    global new_word
    file = open(file_name, "r")
    file2 = open(newfile, "w")

    for line in file:
        line_count = line.count(old_word)

        if line_count > 0:
            count += line_count
            file2.write(line.replace(old_word, new_word))
        else:
            file2.write(line)
    file.close()
    file2.close()
    all_count += count
    os.replace(newfile, file_name)

def not_auto_and_show(file_name):
    count = 0
    line_number = 0
    global all_count
    global old_word
    global new_word
    file = open(file_name, "r")
    file2 = open(newfile, "w")

    for line in file:
        line_number += 1
        line_count = line.count(old_word)

        if line_count > 0:
            show_diff_line(file_name, line_number, line)
            if input("do you want to replae it : (y/n) ") == "y":
                count += line_count
                file2.write(line.replace(old_word, new_word))
            else:
                file2.write(line)
        else:
            file2.write(line)
    file.close()
    file2.close()
    all_count += count
    os.replace(newfile, file_name)

def not_auto_and_not_show(file_name):
    count = 0
    line_number = 0
    global all_count
    global old_word
    global new_word
    file = open(file_name, "r")
    file2 = open(newfile, "w")

    for line in file:
        line_number += 1
        line_count = line.count(old_word)

        if line_count > 0:
            print("file: {0}, line: {1}, match word: {2}. replace or show : (y/s/n) ".format(file_name, line_number, line_count), end="")
            e = input("")
            if e == "y":
                count += line_count
                file2.write(line.replace(old_word, new_word))
            elif e == "s":
                show_diff_line(file_name, line, line_number)
                if input("do you want to replae it : (y/n) ") == "y":
                    count += line_count
                    file2.write(line.replace(old_word, new_word))
                else:
                    file2.write(line)
            else:
                file2.write(line)
        else:
            file2.write(line)
    file.close()
    file2.close()
    all_count += count
    os.replace(newfile, file_name)

if __name__ == "__main__":

    parser = argparse.ArgumentParser(
        description="replace old-text whit new-text",
        epilog="./replace -o old-text -n new-text -f *.txt -r -a")

    parser.add_argument('-o', '--old-word', action="store", help='the old text you want be replace whit the new one', default="")
    parser.add_argument('-n', '--new-word', action="store", help='the new text you want convert old text to this', default="")
    parser.add_argument('-f', '--file', action="store", help='file or files you want to search and replace ror the word', default="*.php")
    parser.add_argument('-d', '--directory', action="store", help='', default="./")
    parser.add_argument('-a', '--auto', action='store_const', const=True, help='automatic', default=False)
    parser.add_argument('-s', '--show', action='store_const', const=True, help='show line', default=False)
    parser.add_argument('-c', '--color', action='store_const', const=True, help='show color', default=False)
    #parser.add_argument('-r', '--recursive', action='store_const', help='search subdirectories recursively', const=True, default=False)

    args = parser.parse_args()
    directory = args.directory
    file = args.file
    file_list = find(file ,directory)
    global old_word
    global new_word
    global _auto
    global _show
    global _color
    old_word = args.old_word
    new_word = args.new_word
    _auto = args.auto
    _show = args.show
    _color = args.color
    #_recursive = args.recursive

    if old_word == "":
        old_word = input("old string = ")
    if new_word == "":
        new_word = input("new string = ")

    for file_name in file_list:
        if _auto and _show:
            auto_and_show(file_name)
        elif _auto and not _show:
            auto_and_not_show(file_name)
        elif not _auto and _show:
            not_auto_and_show(file_name)
        else:
            not_auto_and_not_show(file_name)

    if os.path.exists("new_empty.txt"):
        os.remove("new_empty.txt")
    print("number of replace word is",all_count)

